# Durée totale en minutes
$duree_en_minute = 720

# Fréquence de rafraîchissement (en secondes)
$refresh_en_seconde = 30

# Navigateur cible
$navigateur = "Google Chrome"

# Onglets à rafraîchir
$onglets = @(2, 3, 5)

# Durée du script
$timeout = New-TimeSpan -Minutes $duree_en_minute
$sw = [Diagnostics.Stopwatch]::StartNew()

# Chargement des bibliothèques nécessaires
[void][System.Reflection.Assembly]::LoadWithPartialName("Microsoft.VisualBasic")
[void][System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")

# Fonction pour changer la disposition clavier
function Set-KeyboardLayout {
    param (
        [string]$layout = "00000409"  # QWERTY = 00000409 | AZERTY = 0000040C
    )
    $signature = @'
        [DllImport("user32.dll")]
        public static extern long LoadKeyboardLayout(string pwszKLID, uint Flags);
'@
    $keyboardAPI = Add-Type -MemberDefinition $signature -Name 'Win32Keyboard' -Namespace API -PassThru
    $keyboardAPI::LoadKeyboardLayout($layout, 1)
}

while ($sw.Elapsed -lt $timeout) {

    # Activer la fenêtre navigateur
    [Microsoft.VisualBasic.Interaction]::AppActivate($navigateur)
    Start-Sleep -Milliseconds 500

    # Revenir à l'onglet 1 AVANT chaque cycle
    Set-KeyboardLayout "00000409" # QWERTY
    [System.Windows.Forms.SendKeys]::SendWait("^{1}")
    Start-Sleep -Milliseconds 300
    Set-KeyboardLayout "0000040C" # AZERTY

    foreach ($onglet in $onglets) {
        # Aller à l'onglet voulu
        Set-KeyboardLayout "00000409" # QWERTY
        [System.Windows.Forms.SendKeys]::SendWait("^{${onglet}}")
        Start-Sleep -Milliseconds 300
        Set-KeyboardLayout "0000040C" # AZERTY

        # Rafraîchir
        [System.Windows.Forms.SendKeys]::SendWait("{F5}")
        Start-Sleep -Milliseconds 200

        $dateheure = Get-Date -Format "HH:mm:ss"
        Write-Host "Rafraichissement onglet $onglet ($dateheure)"

        Start-Sleep -Seconds 1
    }

    # Retour à l’onglet 1 en fin de cycle
    Set-KeyboardLayout "00000409" # QWERTY
    [System.Windows.Forms.SendKeys]::SendWait("^{1}")
    Start-Sleep -Milliseconds 300
    Set-KeyboardLayout "0000040C" # AZERTY

    Write-Host "Fin du cycle $(Get-Date -Format "HH:mm:ss"). Attente $refresh_en_seconde sec..."
    Start-Sleep -Seconds $refresh_en_seconde
}
